n = int(input())  
m = int(input())
g = []

for _ in range(m):
    u, v, w = map(int, input().split())
    g.append((w, u, v))


def find(parent, x):
    if parent[x] != x:
        parent[x] = find(parent, parent[x])
    return parent[x]


def union(parent, rank, x, y):
    root_x = find(parent, x)
    root_y = find(parent, y)

    if root_x != root_y:
        if rank[root_x] > rank[root_y]:
            parent[root_y] = root_x
        elif rank[root_x] < rank[root_y]:
            parent[root_x] = root_y
        else:
            parent[root_y] = root_x
            rank[root_x] += 1


parent = [i for i in range(n)]
rank = [0] * n

g.sort()

cost = 0
result = []

for edge in g:
    weight, u, v = edge
    if find(parent, u) != find(parent, v):
        cost += weight
        result.append((u, v))
        union(parent, rank, u, v)

print(cost)
for u, v in result:
    print(u, v)