from collections import defaultdict, deque


def bfs(graph, start, max_dist):
    visited = set()
    queue = deque([(start, 0)])

    while queue:
        node, dist = queue.popleft()

        if node in visited:
            continue

        visited.add(node)

        if dist == max_dist:
            break

        for neighbor in graph[node]:
            if neighbor not in visited:
                queue.append((neighbor, dist + 1))

    return visited


def find_guarded_warehouses(n, m, roads, k, guards):

    graph = defaultdict(list)
    for u, v in roads:
        graph[u].append(v)
        graph[v].append(u)


    guarded = set()

    for p_i, h_i in guards:
        reachable = bfs(graph, p_i, h_i)
        guarded.update(reachable)

    print(len(guarded))
    print(" ".join(map(str, sorted(guarded))))

n, m, k = map(int, input().split())
roads = []
for _ in range(m):
    a, b = map(int, input().split())
    roads.append((a, b))

guards = []
for _ in range(k):
    p_i, h_i = map(int, input().split())
    guards.append((p_i, h_i))

find_guarded_warehouses(n, m, roads, k, guards)