import sys
import itertools
import math

def read_input():
    n = int(sys.stdin.readline().strip())
    points = [tuple(map(int, sys.stdin.readline().strip().split())) for _ in range(n)]
    return n, points

def calculate_distances(points):
    d = [[0] * n for _ in range(n)]
    for i in range(n):
        for j in range(n):
            if i != j:
                d[i][j] = math.sqrt((points[i][0] - points[j][0]) ** 2 + (points[i][1] - points[j][1]) ** 2)
    return d

def tsp(n, dist):
    dp = [[float('inf')] * (1 << n) for _ in range(n)]
    for i in range(n):
        dp[i][1 << i] = 0  # начальная точка

    for mask in range(1 << n):
        for u in range(n):
            if mask & (1 << u):
                for v in range(n):
                    if not (mask & (1 << v)):
                        new_mask = mask | (1 << v)
                        dp[v][new_mask] = min(dp[v][new_mask], dp[u][mask] + dist[u][v])

    answer = min(dp[i][(1 << n) - 1] for i in range(n))
    return answer

n, points = read_input()
distances = calculate_distances(points)
result = tsp(n, distances)
print(f"{result:.12f}")