import sys

sys.setrecursionlimit(10000000)

INF = float('inf')


def manhattan_distance(x1, y1, x2, y2):
    return abs(x1 - x2) + abs(y1 - y2)


def tsp_dp(n, points, memo):
    def rec(mask, pos):
        if mask == (1 << n) - 1:
            return 0
        if (mask, pos) in memo:
            return memo[(mask, pos)]

        min_cost = INF
        for next_pos in range(n):
            if not (mask & (1 << next_pos)):
                cost = rec(mask | (1 << next_pos), next_pos) + manhattan_distance(points[pos][0], points[pos][1],
                                                                                  points[next_pos][0],
                                                                                  points[next_pos][1])
                min_cost = min(min_cost, cost)

        memo[(mask, pos)] = min_cost
        return min_cost

    return rec(1, 0)


def main():
    n = int(input())
    points = [tuple(map(int, input().split())) for _ in range(n)]

    memo = {}
    answer = tsp_dp(n, points, memo)
    print(answer)